-----------------------------------------------------------------------------
--
--	Title: Nextlevel
--
--	Author: Wolfenstein
--
--	Licence: Lesser GNU Version 2.1
--
--	A simple little addon that tell you how many more kills you need after
--	you killed a mod.
--
-----------------------------------------------------------------------------

MyEventFrame = CreateFrame("Frame", "myEventFrame", UIParent)
--MyEventFrame:RegisterEvent("CHAT_MSG_COMBAT_XP_GAIN")
MyEventFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
MyEventFrame:RegisterEvent("PLAYER_XP_UPDATE")

function myEventFrame_OnEvent(self, event, ...)
	if(not kills) then
		kills=0
		leveled=false
		Xp=UnitXP("PLAYER")
		RestedXp=GetXPExhaustion()
		MaxXp=UnitXPMax("PLAYER")
		XpLeft=UnitXPMax("PLAYER")-UnitXP("PLAYER")
		SessionXpGained=0
		SessionPercentGained=0

		if(not RestedXp)
		then
			RestedXp=0
		end

		--DEFAULT_CHAT_FRAME:AddMessage("Xp = " .. Xp)
		--DEFAULT_CHAT_FRAME:AddMessage("RestedXp = " .. RestedXp)
		--DEFAULT_CHAT_FRAME:AddMessage("MaxXp = " .. MaxXp)
		--DEFAULT_CHAT_FRAME:AddMessage("XpLeft = " .. XpLeft)

	else
		kills=kills+1

		newXp=UnitXP("PLAYER")
		newRestedXp=GetXPExhaustion()
		newMaxXp=UnitXPMax("PLAYER")
		newXpLeft=UnitXPMax("PLAYER")-UnitXP("PLAYER")

		if(not newRestedXp)
		then
			newRestedXp=0
		end
		--[[
		if(not newXp)
		then
			newXp=0
		end
		]]

		--DEFAULT_CHAT_FRAME:AddMessage("----------------------------------------")
		--DEFAULT_CHAT_FRAME:AddMessage("Old:")
		--DEFAULT_CHAT_FRAME:AddMessage("Xp = " .. Xp)
		--DEFAULT_CHAT_FRAME:AddMessage("RestedXp = " .. RestedXp)
		--DEFAULT_CHAT_FRAME:AddMessage("MaxXp = " .. MaxXp)
		--DEFAULT_CHAT_FRAME:AddMessage("XpLeft = " .. XpLeft)
		--DEFAULT_CHAT_FRAME:AddMessage("New:")
		--DEFAULT_CHAT_FRAME:AddMessage("newXp = " .. newXp)
		--DEFAULT_CHAT_FRAME:AddMessage("newRestedXp = " .. newRestedXp)
		--DEFAULT_CHAT_FRAME:AddMessage("newMaxXp = " .. newMaxXp)
		--DEFAULT_CHAT_FRAME:AddMessage("newXpLeft = " .. newXpLeft)
		XpGained=newXp-Xp
		--DEFAULT_CHAT_FRAME:AddMessage("Gained " .. XpGained .. " Xp")


		--a=MaxXp
		killXpGained=XpGained
		if(XpGained<0 and leveled==false)
		then
			--DEFAULT_CHAT_FRAME:AddMessage("Level Up.")
			kills=kills-1
			--XpGained=maxXp-Xp+newXp
			--DEFAULT_CHAT_FRAME:AddMessage("Gained " .. XpGained .. " Xp")
			leveled=true
			return
		end
		if(XpGained<0)
		then
			--DEFAULT_CHAT_FRAME:AddMessage("Leveled up")
			leveled=false
			--DEFAULT_CHAT_FRAME:AddMessage("newXP = " .. newXp)
			--DEFAULT_CHAT_FRAME:AddMessage("Xp = " .. Xp)
			--DEFAULT_CHAT_FRAME:AddMessage("MaxXp = " .. MaxXp)
			--DEFAULT_CHAT_FRAME:AddMessage("XpGained = " .. XpGained)
			XpGained=MaxXp-Xp+newXp
			--DEFAULT_CHAT_FRAME:AddMessage("XpGained = " .. XpGained)
			killXpGained=newXp
			SessionXpGained=0
			SessionPercentGained=0
		end
		if(XpGained==0)
		then
			kills=kills-1
			return
		end


		if((newRestedXp==0) and (not (RestedXp==0)))
		then
			--DEFAULT_CHAT_FRAME:AddMessage("most complicated case.")
			--DEFAULT_CHAT_FRAME:AddMessage("newXpLeft = " .. newXpLeft)
			--DEFAULT_CHAT_FRAME:AddMessage("XpGained = " .. XpGained)
			--DEFAULT_CHAT_FRAME:AddMessage("RestedXp = " .. RestedXp)
			--DEFAULT_CHAT_FRAME:AddMessage("RestedXp*0.5 = " .. RestedXp*0.5)
			killsLeft=newXpLeft/(XpGained-(RestedXp*0.5))
		else
			if((newRestedXp==0) or ((newRestedXp+newXp)>newMaxXp))
			then
				--DEFAULT_CHAT_FRAME:AddMessage("Not rested or rested all the way to the next level.")
				--DEFAULT_CHAT_FRAME:AddMessage("newXpLeft = " .. newXpLeft)
				--DEFAULT_CHAT_FRAME:AddMessage("XpGained = " .. XpGained)
				killsLeft=newXpLeft/XpGained
			else
				--DEFAULT_CHAT_FRAME:AddMessage("Partly rested.")
				--DEFAULT_CHAT_FRAME:AddMessage("newRestedXp = " .. newRestedXp)
				--DEFAULT_CHAT_FRAME:AddMessage("XpGained = " .. XpGained)
				--DEFAULT_CHAT_FRAME:AddMessage("newXpLeft = " .. newXpLeft)
				--DEFAULT_CHAT_FRAME:AddMessage("RestedXp = " .. RestedXp)
				killsLeft=((newRestedXp)/(XpGained))+((newXpLeft-newRestedXp)/(XpGained*0.5))
			end
		end
		DEFAULT_CHAT_FRAME:AddMessage("You need to kill " .. math.floor(killsLeft*1000)/1000 .. " more like that to level up. ")
		--DEFAULT_CHAT_FRAME:AddMessage("You need to kill " .. math.floor(killsLeft) .. " more like that to level up. ")
		--DEFAULT_CHAT_FRAME:AddMessage((newXp/newMaxXp)*100 .. "% done. That kill was " .. (XpGained/newMaxXp)*100 .. "%.")
		Xp=newXp
		RestedXp=newRestedXp
		MaxXp=newMaxXp
		XpLeft=newXpLeft
		SessionXpGained=SessionXpGained+killXpGained
		SessionPercentGained=SessionPercentGained+(killXpGained/newMaxXp)*100
		--DEFAULT_CHAT_FRAME:AddMessage("Kills = " .. kills .. " this session. XP Left = " .. newXpLeft .. " Rested Xp = " .. newRestedXp)
		--DEFAULT_CHAT_FRAME:AddMessage("This session XP = " .. SessionXpGained .. ". Precent = " .. SessionPercentGained .. "%")
	end
end

MyEventFrame:SetScript("OnEvent",myEventFrame_OnEvent)
